<?php
/*
    Stepmania BBStep Creator
    (c) 2009 David Lippman

    ver 0.1  3/13/09

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
$oktoproc = false;
$err = '';
if (isset($_FILES['toproc'])) {
	if (is_uploaded_file($_FILES['toproc']['tmp_name'])) {
		$ext = substr($_FILES['toproc']['name'], strrpos($_FILES['toproc']['name'], '.'));
		if ($ext != '.sm' && $ext != '.bak') {
			$err = "Must upload a .sm or .bak file.";
		} else {
			$str = file_get_contents($_FILES['toproc']['tmp_name']);
			$oktoproc = true;
		}
	} else {
		$err = "Error with upload.  Try again.";
	}
}

if (!$oktoproc) {
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<title>Stepmania BBStep Generator</title>
<link rel="stylesheet" href="step.css" type="text/css" />

</head>
<body>
<div id="main">
<div class="h1"><span style="font-size: 150%;">Stepmania BBStep Generator</span><br/>
<span style="font-size: 100%">Step Aerobics with the Wii Balance Board and Stepmania</span></div>
<div id="content">
<p>The step aerobics that came with Wii Fit is fun, but playing the same song and pattern gets old after a while.</p>
<p>This service takes Stepmania step files (.sm files) and creates an
alternative step file which can be used to create step-aerobics style step
patterns to be used with the Wii Balance Board.</p>

<p>The pattern is randomly generated
from a set of predetermined stepping patterns, so the result is always steppable.  If
you don't like the flow, or want to change things up, you can generate a new step file.</p>

<p>To get this to all work, you will need to:
<ul>
 <li>Have a Wii Balance Board, which comes with Wii Fit.</li>
 <li>Get a bluetooth adapter for your computer if you don't already have one, like 
    <a href="http://www.amazon.com/gp/redirect.html?ie=UTF8&location=http%3A%2F%2Fwww.amazon.com%2Fs%3Fie%3DUTF8%26x%3D0%26ref%255F%3Dnb%255Fss%255Fvg%26y%3D0%26field-keywords%3Dbluetooth%2520adapter%2520usb%26url%3Dsearch-alias%253Dvideogames&tag=i0f80-20&linkCode=ur2&camp=1789&creative=390957">one of these</a><img src="https://www.assoc-amazon.com/e/ir?t=i0f80-20&l=ur2&o=1" width="1" height="1" border="0" alt="" style="border:none !important; margin:0px !important;" />.  
    I've had good luck with ones using BlueSoleil software.</li>
 <li>Download <a href="http://carl.kenner.googlepages.com/glovepie_download">GlovePie</a>.</li>
 <li>Install <a href="http://www.stepmania.com/wiki/Downloads">Stepmania</a>, and <a href="http://www.stepmania.com/wiki/Download_and_Install_Songs">download and install some songs</a> from their site.</li>
 <li>Open up the song's directory, and rename the original .sm file with a .bak extension. </li>
 <li>Upload the .bak file from a song below (or the .sm file if you don't mind overwriting it).</li>
 <li>Click Go, and save the output .sm file into the song directory.</li>
 <li>Download the and unzip the <a href="images.zip">image pack</a> into the song folder.</li>
</ul>
To play:
<ul>
 <li>Connect your Balance Board to your PC via Bluetooth.  If you don't know how to do this, try <a href="http://www.wiiprojects.org/bluetooth.html">this tutorial</a>, but press the red sync button on the Balance Board (inside battery compartment) at Step 3.</li>
 <li>Optionally connect a wiimote to your PC via Bluetooth.</li>
 <li>Load up <a href="BBstep.PIE">this script</a> in GlovePIE.</li>
 <li>Start up the script, and step on and off the Balance Board a few times to calibrate it.</li>
 <li>Start up Stepmania, select the song(s) you processed, and start stepping.  There's no scrolling feet like Wii Fit,  
     but an image will display <a href="steppat.html">showing the steps to follow</a>.</li>
</ul>
</p>

<?php
if ($err != ''){
	echo "<p style=\"color:red\">$err</p>";
}
?>

<form method="post" enctype="multipart/form-data" >
<input type="hidden" name="MAX_FILE_SIZE" value="300000" />
.bak/.sm file to process: <input name="toproc" type="file" /><br/>
Speed: <input type="radio" name="speed" value="full" checked="checked"/>1 step per beat <input type="radio" name="speed" value="half"/>1 step per 2 beats<br/>
Type: <input type="radio" name="type" value="step" checked="checked"/> Step aerobics <input type="radio" name="type" value="box"/> Cardio boxing<sup>*</sup><br/>
<input type="submit" value="Go"/>
</form>
<p>
<sup>*</sup>Cardio boxing is a work in progress.  Punch left (nunchuck) on down arrow; punch right (wiimote) on up arrow.  Step on balance board for left/right arrows
</p>
<p>If you want to try some other Wii exercise games, I've enjoyed:<br/>
<a href="http://www.amazon.com/gp/product/B0018BEG8W?ie=UTF8&tag=i0f80-20&linkCode=as2&camp=1789&creative=9325&creativeASIN=B0018BEG8W">Dance Dance Revolution Hottest Party 2</a><img src="http://www.assoc-amazon.com/e/ir?t=i0f80-20&l=as2&o=1&a=B0018BEG8W" width="1" height="1" border="0" alt="" style="border:none !important; margin:0px !important;" /><br/>
<a href="http://www.amazon.com/gp/product/B001H0RZX2?ie=UTF8&tag=i0f80-20&linkCode=as2&camp=1789&creative=9325&creativeASIN=B001H0RZX2">My Fitness Coach</a><img src="http://www.assoc-amazon.com/e/ir?t=i0f80-20&l=as2&o=1&a=B001H0RZX2" width="1" height="1" border="0" alt="" style="border:none !important; margin:0px !important;" />
</p>
<div style="text-align: right; font-size: 80%; margin-top: 20px;">&copy; 2009 David Lippman, dlippman[at]imathas[dot]com.<br/>
Want to modify this Creator?  <a href="BBstep.zip">Download</a>.  GPL Licensed.</div>
</div>
</div>
</body>
</html>
<?php
exit;
} else {
 
header('Content-type: text/sm');
$outname = substr($_FILES['toproc']['name'], 0, strrpos($_FILES['toproc']['name'], '.'));
		
header("Content-Disposition: attachment; filename=\"$outname.sm\"");
		
//break original .sm file into tokens
$tokens = explode('#',$str);
$tokendata = array();
$measures = 0;
$speed = $_POST['speed'];
if ($speed == 'half') {
	$speedm = 2;
} else {
	$speedm = 1;
}

//write out all the tokens except the two we plan to change
foreach($tokens as $token) {
	if (strpos($token,':')) {
		$p = explode(':',$token);
		if ($p[0]!='BGCHANGES' && $p[0]!='NOTES') {
			echo('#'.$token);	
		}
		if ($p[0] == 'NOTES') {
			$c = substr_count($p[6],',')+1;
			if ($c > $measures) {
				$measures = $c;
			}
		}
	}
}
$type = $_POST['type'];
if ($type=='step') {
	//this defines the step patterns and the associated image files
	//all patterns start on the left foot for flow
	//elements are left00right - we're not using up or down, so up/down are 0
	//1: tap, 2: start hold, 3: release hold
	//one measure patterns
	$one = array (
		"2000\n3002\n0003\n0000\n", 'pat11.png'
	);
	//two measure patterns
	$two = array (
		"2000\n3002\n0003\n0000\n,1000\n0000\n0001\n0000\n", 'pat21.png',
		"2000\n0001\n3000\n0000\n,0002\n1000\n0003\n0000\n", 'pat22.png',
		"1000\n0001\n1000\n0001\n,1000\n0001\n0000\n0000\n", 'pat23.png'
	);
	//three measure patterns
	$three = array (
		"2000\n3002\n0003\n1000\n,0002\n2003\n3000\n0001\n,2000\n3002\n0003\n0000\n", 'pat31.png'
	);
} else if ($type=='box') {
	$one = array (
		"0100\n0000\n0010\n0000\n", '',
		"0010\n0000\n0100\n0000\n", '',
		"0100\n0010\n0100\n0010\n", '',
		"0010\n0100\n0010\n0100\n", '',
		"2000\n0010\n3100\n0000\n", '',
		"0002\n0100\n0013\n0000\n", '',
	);
	$two = array();
	$three = array();
	
} else {
	echo "Error - Invalid type!";
	exit;
}
//prepare the notes and bgchanges strings
$notes = "#NOTES:\ndance-single:\n:\nEasy:\n3:\n0,0,0,0,0:\n";
$bgchanges = '#BGCHANGES:';

$notearr = array();
$allsteps = array_merge($one,$two,$three);
$beat = 0;
$cnt = 0;
$measuressincebasic = 0;
//start generating
while ($measures>0 && $cnt<50) {
	//randomly select a step pattern
	//at beginning and if we haven't seen a basic in a while, force a 
	//one-measure pattern
	if ($cnt>2 && $measures>2*$speedm && $measuressincebasic<10) {
		$n = rand(0,count($allsteps)/2-1);
	} else {
		$n = rand(0,count($one)/2-1);
		$measuressincebasic = 0;
	}
	//add the step pattern and background image
	if ($speed=='half') {
		$ntmp = explode("\n",$allsteps[$n*2]);
		$ntmpo = array();
		for ($i=0;$i<count($ntmp)-1;$i++) {
			$ntmpo[] = $ntmp[$i];
			if ($i%2==1 && $i%4!==3) {
				$ntmpo[] = "0000,";	
			} else {
				$ntmpo[] = "0000";
			}
		}
		$notearr[] = implode("\n",$ntmpo);
	} else {
		$notearr[] = $allsteps[$n*2];
	}
	if ($allsteps[$n*2+1] != '') {
		$bgarr[] = ($beat-.5).'='.$allsteps[$n*2+1];
	}
	
	//calculate length so we know how many measures we have left
	$length = substr_count($allsteps[$n*2],"\n");
	if ($length>4) {
		$measuressincebasic += round($length/4);
	}
	//recordkeeping - what beat are we at and how many measures are left?
	$beat += $length*$speedm;
	$measures -= $speedm*round($length/4);
	
	$cnt++;
}

//write out bgchanges and notes
if (count($bgarr)) {
	$bgchanges .= implode(',',$bgarr) . ";\n";
	echo $bgchanges;
}
$notes .= implode(',',$notearr) . ";\n";
echo $notes;

}

?>
